package com.sitemesh.taglib.decorator;

import com.sitemesh.HTMLPage;
import com.sitemesh.taglib.AbstractTag;
import javax.servlet.jsp.JspException;

/**
 * Write property of Page to out.
 *
 * @author <a href="joe@truemesh.com">Joe Walnes</a>
 * @version $Revision: 1.2 $
 *
 * @see com.sitemesh.Page#getProperty(java.lang.String)
 */
public class PropertyTag extends AbstractTag {

	private String propertyName, defaultValue;

	/**
	 * Key of property to write.
	 */
	public void setProperty( String propertyName ) {
		this.propertyName = propertyName;
	}

	/**
	 * Value to write if no property matching key is found (optional).
	 */
	public void setDefault( String defaultValue ) {
		this.defaultValue = defaultValue;
	}

	public int doEndTag() throws JspException {
		try {
			HTMLPage htmlPage = ( HTMLPage )getPage();
			String result = htmlPage.getProperty(propertyName);
			if ( result == null || result.length() == 0 ) result=defaultValue;
			pageContext.getOut().print( result );
		}
		catch ( Exception e ) {
			trace( e );
		}
		return EVAL_PAGE;
	}

	public void release() {
		defaultValue = null;
		propertyName = null;
		super.release();
	}

}
